; DO NOT TUCH !
_nostub:
	xdef	_nostub
_ti92plus:
	xdef	_ti92plus

	dc.b	"SXES"			; Signature
; END OF 'DO NOT TUCH'

; Include main files
	include "sprite.h"		; Sprite header file
	include "object.h"		; Sma object / sma sprite
	include "data.h"		; To access sma data
	include "Internal.asm"		; Usefull macros :)

; Include sprite header diles
	include "spr_sonc.h"		; Sonc include file
	include "spr_fish.h"		; Fish include file
	include "spr_crab.h"		; Crabe include file
	include "spr_scar.h"		; Scarab include file
	include "spr_jaws.h"		; Jaws include file
	include "spr_catt.h"		; Catter driller & Mangor include file
	include "spr_ript.h"		; Riptor include file
	include "spr_mouc.h"		; Mouche include file
	include "spr_shot.h"		; Shoot include file
	include "spr_mstr.h"		; Monstro include file
	include "spr_buzz.h"		; Buzz include file
	include "spr_pic.h"		; Pic include file
	include "spr_nib.h"		; Nibbles include file

; Const for anim table
ANI_FISH	EQU	0
ANI_CRABE	EQU	4
ANI_DRILLER	EQU	8

Sprite_table:
 ADD_SPRITE	SPR_FISH,fish_init,fish_exe,Size_fish,0,0,P16X16_ANI,-1,ANI_FISH,Fish_image		;0
 ADD_SPRITE	SPR_CRABE,crabe_init,crabe_exe,Size_crabe,0,-7,PBGS_ANI,-1,ANI_CRABE,Crabe_image		;1
 ADD_SPRITE	SPR_SCARAB,scarab_init,scarab_exe,Size_scarab,0,0,P16X16,-1,0,scarab_image		;2
 ADD_SPRITE	SPR_JAWS,Jaws_init,Jaws_exe,Size_jaws,0,0,P16X16,-1,0,Jaws_image				;3
 ADD_SPRITE	SPR_CATTER,catter_init,catter_exe,Size_catter,0,0,PBGS_ANI,-1,ANI_CRABE,catter_image	;4
 ADD_SPRITE	SPR_MANGOR,mangor_init,catter_exe,Size_catter,0,0,PBGS,-1,0,mangor_image			;5
 ADD_SPRITE	SPR_RIPTOR,riptor_init,riptor_exe,Size_riptor,0,0,PBGS,-1,0,Riptor_image			;6
 ADD_SPRITE	SPR_MOUCHE,mouche_init,mouche_exe,Size_mouche,0,0,PBGS,-1,0,mouche_image			;7
 ADD_SPRITE	SPR_MONSTRO,monstro_init,monstro_exe,Size_monstro,0,0,PBGS_ANI,-1,ANI_FISH,Monstro_image	;8
 ADD_SPRITE	SPR_BUZZ,buzz_init,buzz_exe,Size_buzz,0,0,PBGS,-1,0,Buzz_img				;9
 ADD_SPRITE	SPR_NIB,nib_init,nib_exe,size_nib,0,0,P16X16,-1,0,nib_image				;10
 ADD_NOTHING	;11
 ADD_NOTHING	;12
 ADD_NOTHING	;13
 ADD_NOTHING	;14
 ADD_NOTHING	;15
 ADD_SPRITE	SPR_SHOOT,shoot_init,shoot_exe,Size_shoot,0,0,P16X16,-1,0,shoot_image	;0'
 ADD_SPRITE	SPR_PIC,pic_init,pic_exe,size_pic,0,0,P16X16,-1,0,pic_image		;1'

 FINISH_SPRITE_TABLE
 END_SPRITE_TABLE
		
Anim_table:
	dc.w	0
	dc.b	2,4
	dc.w	0
	dc.b	3,6
	dc.w	0
	dc.b	3,10

; Include code...
	include "spr_fish.asm"
	include "spr_crab.asm"
	include "spr_scar.asm"
	include "spr_catt.asm"
	include "spr_ript.asm"
	include "spr_mouc.asm"
	include "spr_shot.asm"
	include "spr_mstr.asm"
	include "spr_buzz.asm"
	include "spr_pic.asm"
	include "spr_nib.asm"
	include "spr_jaws.asm"

; Include routines ...
	include "ext_func.asm"
; End
	end
