; Catter driller & mangor

catter_init:
	lea	Anim_table(Pc),a0
	move.l	a0,Ani_adr(a5)
	moveq	#CATTER_HEIGHT,d0
	bra.s	catter_init2

mangor_init:
	moveq	#MANGOR_HEIGHT,d0
catter_init2:
	move.w	d0,Catter_height(a5)
	move.w	#1,Catter_Vx(a5)
	move.l	d6,d4
	swap	d4
	cmp.w	Xj(a5),d4
	bhi.s	\ok
	neg.w	Catter_Vx(a5)
\ok:	rts

catter_exe:
	move.w	Xj(a5),d0
	move.w	Yj(a5),d1
	move.w	Catter_height(a5),d4
	lsr.w	#1,d4
	addq.w	#1,d4

	; Move X
	add.w	Catter_Vx(a5),d0
	move.w	d0,Xj(a5)
	add.w	d4,d1

	or.b	#%00000010,Drawing(a5)
	tst.w	Catter_Vx(a5)
	blt.s	\ok
	add.w	#22,d0
	and.b	#%11111101,Drawing(a5)
\ok:	test_mur2.s	<read_a4>,catter_X_done
	neg.w	Catter_Vx(a5)
	add.w	Catter_Vx(a5),d0
catter_X_done:
	
	; Correction in function of the surface
	move.w	Xj(a5),d0
	add.w	#22/2,d0
	add.w	d4,d1
	bsr	Calc_surface
	sub.w	Catter_height(a5),d3
	move.w	d3,Yj(a5)

	; Coordinate of the center of gravity
	move.w	d3,d1
	add.w	d4,d1

	; Collision ?
	test_sonic_collision2.s d0,d1,22,16,d2,d3,catter_no_collision
	move.l	Sprite_adr(a6),a3
	tst.b	Force(a3)
	blt	explode
	tst.w	Action(a3)
	bne.s	\ouille
	tst.b	Boule(a3)
	bne	explode
\ouille	move.b	#1,Force(a3)		; Ouille !
catter_no_collision:

	; Exit the screen ?
	test_exit_screen.s d0,d1,d2,catter_outside
	rts

catter_outside:
	move.w  Offset(a5),d0
	moveq	#OBJ_EXT4/4,d1
	cmp.w	#CATTER_HEIGHT,Catter_height(a5)
	beq.s	\catter
	moveq	#OBJ_EXT5/4,d1
\catter	move.b  d1,0(a4,d0.w)
	bra	DestroySprite

catter_image:
	dc.w	Driller1-catter_image
	dc.w	Driller2-catter_image
	dc.w	Driller3-catter_image

Driller1: incbin "driller1.bin"
Driller2: incbin "driller2.bin"
Driller3: incbin "driller3.bin"

mangor_image:
	incbin "mangor.bin"
