; *********************************************************************
; 			Crabe
; *********************************************************************
	
crabe_init:
	lea	Anim_table(Pc),a0
	move.l	a0,Ani_adr(a5)
	move.w	#CRABE_TMP,Crabe_loop(a5)
	move.w	#-1,Crabe_Vx(a5)
	rts

crabe_exe:
	; Move the sprite
	move.w  Xj(a5),d0
	move.w  Yj(a5),d1
	add.w   Crabe_Vx(a5),d0
	move.w  d0,Xj(a5)
	subq.w	#1,Crabe_loop(a5)
	bgt.s	\Ok
	move.w  #CRABE_TMP,Crabe_loop(a5)
	neg.w	Crabe_Vx(a5)
\Ok:
	addq.w	#7,d0

	; Correction in function of the surface
	add.w	#25,d1
	bsr	Calc_surface
	sub.w	#22,d3
	move.w	d3,Yj(a5)

	; Center of gravity
	move.w	d3,d1
	addq.w	#7,d1

	; Collision ?
	test_sonic_collision2.s d0,d1,16,16,d2,d3,crabe_no_collision
	bra	Hurt
crabe_no_collision:

	; Exit the screen ?
	test_exit_screen.s d0,d1,d2,crabe_outside
	rts

crabe_outside:
	move.w  Offset(a5),d0
	move.b  #OBJ_EXT1/4,0(a4,d0.w)
	bra	DestroySprite

Crabe_image:
	dc.w	Crabe1-Crabe_image
	dc.w	Crabe2-Crabe_image
	dc.w	Crabe3-Crabe_image


Crabe1:	incbin "crabe1.bin"
Crabe2:	incbin "crabe2.bin"
Crabe3:	incbin "crabetir.bin"
