; *********************************************************************
; 				Riptor
; *********************************************************************

riptor_init:
	move.w	#1,Riptor_Vx(a5)
	move.l	d6,d4
	swap	d4
	cmp.w	Xj(a5),d4
	bhi.s	\ok
	neg.w	Riptor_Vx(a5)
\ok:	move.w	#5,Riptor_wait(a5)
	rts

riptor_exe:
	move.w	Xj(a5),d0
	move.w	Yj(a5),d1
	move.w	Riptor_Vx(a5),d4

	; Move X
	add.w	d4,d0
	move.w	d0,d3	; Save X
	add.w	#12,d1

	or.b	#%00000010,Drawing(a5)
	tst.w	d4
	blt.s	\ok
		add.w	#20,d0
		and.b	#%11111101,Drawing(a5)
\ok:	test_mur2.s	<read_a4>,Riptor_X_done
		sub.w	d4,d3
Change_direction:
		moveq	#12,d0
		bsr	Random
		addq.w	#8,d0
		move.w	d0,Riptor_wait(a5)
		moveq	#5,d0
		bsr	Random
		subq.w	#2,d0
		move.w	d0,Riptor_Vx(a5)
Riptor_X_done:
	move.w	d3,Xj(a5)
	move.w	d3,d0

	; Attente
	subq.w	#1,Riptor_wait(a5)
	beq.s	Change_direction
	
	; Correction in function of the surface
	add.w	#10,d0
	add.w	#(26-12),d1
	bsr	Calc_surface
	sub.w	#24,d3
	move.w	d3,Yj(a5)

	; Coordinate of the center of gravity
	move.w	d3,d1
	add.w	#12,d1

	; Collision ?
	test_sonic_collision2.s d0,d1,20,24,d2,d3,Riptor_no_collision
	bra	Hurt
Riptor_no_collision:

	; Exit the screen ?
	test_exit_screen.s d0,d1,d2,Riptor_outside
	rts

Riptor_outside:
	move.w  Offset(a5),d0
	move.b  #OBJ_EXT6/4,0(a4,d0.w)
	bra	DestroySprite


Riptor_image:
	incbin "Riptor.bin"
