#include "include.h"
#include "macro.h"

#include "editor.h"
#include "string92.h"

#define MAX_DATA 65536 

 ul No = 0;
 ul F_pos = 0;
 LEVEL L;
 char World_name[512];

int	load_data()
{
 FILE	*F;
 if (!(F=fopen("data.$$$","rb")))
	return 0;
 fread(&No,sizeof(ul),1,F);
 fread(&F_pos,sizeof(ul),1,F);
 fread(&L,sizeof(L),1,F);
 fread(World_name,sizeof(char),512,F);
 fclose(F);
 system("del data.$$$");
 return 1;
}

// Routine bidon pour economiser de la memoire en mode DOS...
void	exec_program(char *program)
{
 FILE	*F;
 /* Sauvegarde des donnees pour le retour */
 F=xopen("data.$$$","wb");
 fwrite(&No,sizeof(ul),1,F);
 fwrite(&F_pos,sizeof(ul),1,F);
 fwrite(&L,sizeof(L),1,F);
 fwrite(World_name,sizeof(char),512,F);
 xclose(F);
/* Creation du fichier Mkexec.bat*/
 F=xopen("mkexec.bat","w");
 fprintf(F,"%s\n mkwld %%1\n",program);
 xclose(F);
 exit(0);
}

void	scan_str(FILE *F, char *str)
{
 while ((*str = fgetc(F)) != '\n') str++;
 *str = NULL;
}

void main(int argc,char *argv[])
{
 FILE *F;
 ub Data[512];
 ub *temp;
 ub *Option;
 ub *a0;
 ub *a1;
 ul i,j,k;
 ub Signature_d[]={'S','X','L','1'};

 puts ("\tSMA Level compilor v"VERSION" by PpHd");

 if (argc < 2)
    {
    printf("Usage : %s World.txt",argv[0]);
    return;
    }

 F = xopen(argv[1],"r");

 temp = xalloc(sizeof(ub) * MAX_DATA);

 strcpy(L.Level_name,"User file");

 if	(load_data())
	{
	for(i=0; i < F_pos ; i++) scan_str(F,temp);
        sprintf(Data,"LEV%u.TMP",No++);
	finish_level(&L, Data);
	}

 while (!(feof(F)))
       {
        //fscanf(F,"%s\n",temp);
        scan_str(F,temp);
        F_pos++;
	a0 = temp;
        i = 1;
        for( j = 0 ; (j < 512) && (*(a0)) ; j++, a0++)
             if (*(a0) == '=')
		{
		a0++;
		i =2;
		break;
		}
        strncpy(Data, temp, j);
        *(Data + j)=NULL;
        Option = a0;

        if (i == 2)
           {
            j = sscanf(Option,"%u",&k);
            if (strcmp(Data,"graph1") == 0)
               strcpy(L.Graph1_file,Option);
            else if (strcmp(Data,"graph2") == 0)
               strcpy(L.Graph2_file,Option);
            else if (strcmp(Data,"sprite") == 0)
               strcpy(L.Sprite_file,Option);
            else if (strcmp(Data,"plan2") == 0)
               strcpy(L.Plan2,Option);
            else if (strcmp(Data,"animation") == 0)
               strcpy(L.Anim_file,Option);
            else if (strcmp(Data,"gfx_tab") == 0)
               strcpy(&(L.Gfx_file[0]),Option);
            else if (strcmp(Data,"test_tab") == 0)
               strcpy(L.Test_file,Option);
            else if (strcmp(Data,"world_name") == 0)
               strcpy(World_name,Option);
            else if (strcmp(Data,"level_name") == 0)
               strcpy(L.Level_name,Option);
            if (j == 1)
               {
                if (strcmp(Data,"mx") ==0)
                   L.Mx = k;
                else if (strcmp(Data,"my") == 0)
                     L.My = k;
                else if (strcmp(Data,"sx") == 0)
                     L.Sx = k;
                else if (strcmp(Data,"sy") == 0)
                     L.Sy =k;
                else if (strcmp(Data,"sx2") == 0)
                     L.Sx2 = k;
                else if (strcmp(Data,"sy2") == 0)
                     L.Sy2 = k;
                else if (strcmp(Data,"startx") == 0)
                     L.Startx = k;
                else if (strcmp(Data,"starty") == 0)
                     L.Starty = k;
                else if (strcmp(Data,"P1") == 0)
                     L.Type_P1 = k;
                else if (strcmp(Data,"P2") == 0)
                     L.Type_P2 = k;
               }
           }
        else if (i ==1)
             {
              if (strcmp(Data,"endlevel") == 0)
                 {
                 //sprintf(Data,"L%u.$$$",No++);
                 if (create_level(&L))
                        {
                         printf("Error when making level\n");
                         return;
                        };
                 }
              else if (strcmp(Data,"endworld") ==0)
                   {
                    printf("\nMaking world : %s (%u levels)...\n", World_name, No);
                    a0 = temp;
                    // Signature, i doit etre egal a la taille du niveau
                       for(i = 0 ; i< 4 ; i++)
                          *(a0++) = Signature_d[i];
                    
                    // Nombre de niveaux
                    *(a0++) = 0, *(a0++) = (No & 255);
                    i += 2;
                    // Table des offsets
                    a1 = a0;           // Offset
                    a0 += (No) *2; // Debut des donnes
                    i += (No) * 2;
                    // Donnes
                    for (k = 0 ; k < No ; k++)
                        {
                        sprintf(Data,"LEV%u.TMP",k);
                        F = xopen(Data,"rb");
                        j = fread(a0, sizeof(ub), MAX_DATA, F);
                        xclose(F);
                        *(a1++) = LSR( (a0 - temp - 4),8) & 255;
                        *(a1++) = (a0 - temp - 4) & 255;
                        a0 += j;
                        i += j;
			// Alignement (2x) ?
			if (i % 2)
				i++,a0++;	// Inc si on est sur une adresse impaire
                        printf("Level %u ; size %u \n", k, j);
                        }

                    printf("World length : %u\n",i);

                    (Create92S(temp, i, World_name));
                    system("del *.$$$");
                    printf("All done !\n");
			F=xopen("mkexec.bat","w");
			xclose(F);
                    return ;
                   }
             }
       }
 system("del *.$$$");
 F=xopen("mkexec.bat","w");
 xclose(F);
 puts("Error : No directive 'endworld' found !\n");
 return;
}
