#include "include.h"
#include "macro.h"

#define MAX_ANI_TILE 50
#define MAX_STR 256
#define MAX_NBR 5

#define MAX_COMMANDE 5
#define MAX_FREQ 6

typedef struct
{
 ub   freq;
 ub   type;
 ub   opt1;
 ub   opt2;
 ub   opt3;
 ub   opt4;
} ANI_TILE;

ul type_opt[MAX_COMMANDE] = {2,2,2,2,3};

ANI_TILE tile[MAX_ANI_TILE];
ul nbr_tile=0;
char name_str[MAX_STR];

char *commande2[]={"freq","type","opt1","opt2","opt3","opt4","include","name",0};
char *commande1[]={"new","end",0};

void	save()
{
 FILE *F;
 ul i,j,k;

 F = xopen(name_str,"wb");
 for(i = 0 ; i < MAX_FREQ ; i++)
  for(j = 0 ; j < nbr_tile ; j++)
   if ((tile[j]).freq == i)
	fwrite(&((tile[j]).type),sizeof(ub),type_opt[((tile[i]).type)],F);
 xclose(F);
}

void create_tile(char *name)
{
 ANI_TILE current;
 FILE *F;
 ul j;
 ub nbr_arg,nbr;
 ub *a0;
 ub *a1;
 char str0[MAX_STR];

 F = xopen(name,"r");
  while (!(feof(F)))
	{
	fscanf(F,"%s\n",str0);
	a0 = str0;
        nbr_arg = 0;
        for( j = 0 ; (j < 256) && (*(a0)) ; j++, a0++)
             if (*(a0) == '=')
		{
		a0++;
		nbr_arg = 1;
		break;
		}
	if (nbr_arg)
	{
        *(str0 + j)=NULL;
        sscanf(a0,"%u",&nbr);
	j=0;
	while (!(a1))
	 {
	  if (!(strcmp(str0,a1 = commande2[j])))
		break;
	  j++;
	 }
	if (a1)
		switch (j)
		{
		case 0: current.freq = nbr;
			break;
		case 1: current.type = nbr;
			break;
		case 2: current.opt1 = nbr;
			break;
		case 3: current.opt2 = nbr;
			break;
		case 4: current.opt3 = nbr;
			break;
		case 5: current.opt4 = nbr;
			break;
		case 6: create_tile(a0);
			break;
		case 7: strcpy(name_str,a0);
			break;
		default: break;
		}
	}
	else
	{
	j=0;
	while (!(a1))
	 {
	  if (!(strcmp(str0,a1 = commande1[j])))
		break;
	  j++;
	 }
	if (a1)
		switch (j)
		{
		case 0: tile[nbr_tile++]=current;
			break;
		case 1: save();
			exit(0);
		default: break;
		}
	}
	}
 xclose(F);
}

int main(int argc, char *argv[])
{
 
 puts("Make animated tiles for sma");
 if (argc<2)
    xerror("Error : mktile tilefile.ani");
 strcpy(name_str,"tile.bin");
 create_tile(argv[1]);
}