#include "include.h"
#include "macro.h"
#include "ObjTile.h"

extern BITMAP *buffer;	/* Ecran de sortie*/

/* Fichier plan */

typedef struct plane_struct Plane;

struct plane_struct
{
char plane_file[MXS];  // Nom du fichier binaire du plan
char tile_name[MXS];   // Nom du fichier binaire des dessins
char link_file[MXS];   // Nom du fichier link
ul skip_byte;          // Nombre d'octets  sauter avant d'crire le plan
uw height;             // Hauteur
uw length;             // Largeur
uw sub_height;		// Sous hauteur
uw sub_length;		// Sous largeur
uw type;               // Type des dessins
uw taille;             // Taille des dessins : ce doit tre des carrs
uw tile_no;            // Nombre de dessins chargs
uw xs;                 // Coordonne horizontale du scroling
uw ys;                 // Coordonne verticale du scrolling
uw list_no;            // Slection courante dans la liste des dessins
uw list_no2;           // 2eme Slection ds la liste
sw list_s;             // Coordonne du scrolling courant de la liste
ub *pl_tab;            // Pointeur vers le tableau du plan
sw link_no;	       // Numro du plan link, -1 si aucun
Plane *Plink;          // Pointeur vers le plan link
ub *link_tab;          // Adresse de la table de linkage
BITMAP *tile[MAX_TILE]; // Table de pointeurs vers les dessins
};

/* Dfinition des fonctions */
void init_plane(Plane *);
void init_plane2(Plane *);
void save_plane(Plane *);
void open_plane(Plane *);
void open_link(Plane *);
void save_link(Plane *);
void print_Ptile(Plane *, uw, uw, ub);
ub   load_Ptile(Plane *);
ub   select_link(Plane *, ub);
void edit_link(Plane *);
