; *********************************************************************
; 			Fish
; *********************************************************************

fish_init:
	lea	Anim_table(Pc),a0
	move.l	a0,Ani_adr(a5)
	move.w	#FISH_JUMP,Fish_loop(a5)
	move.w	#-4,Fish_Vy(a5)
	rts

fish_exe:
	; Move the sprite
	move.w  Xj(a5),d0
	move.w  Yj(a5),d1
	add.w   Fish_Vy(a5),d1
	move.w  d1,Yj(a5)
	subq.w	#1,Fish_loop(a5)
	bgt.s	\Ok
	move.w  #FISH_JUMP,Fish_loop(a5)
	neg.w	Fish_Vy(a5)
\Ok:
	; Collision ?
	addq.w	#7,d0
	addq.w	#7,d1

	test_sonic_collision2.s d0,d1,16,16,d2,d3,fish_no_collision
	bra	Hurt
fish_no_collision:

	; Exit the screen ?
	test_exit_screen.s d0,d1,d2,fish_outside
	rts

fish_outside:
	move.w  Offset(a5),d0
	move.b  #OBJ_EXT0/4,0(a4,d0.w)
	bra	Destroy_sprite

Fish_image:
	incbin "fish1.bin"
	incbin "fish2.bin"
