; *********************************************************************
; 			Jaws
; *********************************************************************

Jaws_init:
	move.w	#1,Jaws_Vx(a5)
	move.l	d6,d4
	swap	d4
	cmp.w	Xj(a5),d4
	bhi.s	\ok
		neg.w	Jaws_Vx(a5)
\ok:	rts

Jaws_exe:
	moveq	#16,d4

	move.w	Xj(a5),d2
	move.w	Yj(a5),d1

	; Move X
	add.w	Jaws_Vx(a5),d2
	move.w	d2,Xj(a5)

	; Move Y
	move.l	d7,d0
	swap	d0
	and.w	#%0111,d0
	bne.s	Jaws_noY
		moveq	#5,d0
		bsr	Random
		subq.w	#2,d0
		add.w	d0,d1
		test_mur.s	<read_a4>,Jaws_noY
		move.w	d1,Yj(a5)
Jaws_noY:
	move.w	d2,d0
	addq.w	#7,d1

	; Test
	or.b	#%00000010,Drawing(a5)
	tst.w	Jaws_Vx(a5)
	blt.s	\ok
		add.w	d4,d0
		and.b	#%11111101,Drawing(a5)
\ok:	test_mur2.s	<read_a4>,Jaws_X_done
	neg.w	Jaws_Vx(a5)
Jaws_X_done:
	
	; Coordinate of the center of gravity
	move.w	Xj(a5),d0
	addq.w	#7,d0
	addq.w	#7,d1

	; Collision ?
	test_sonic_collision2.s d0,d1,16,16,d2,d3,Jaws_no_collision
	bra.s	Hurt
Jaws_no_collision:

	; Exit the screen ?
	test_exit_screen.s d0,d1,d2,Jaws_outside
	rts

Jaws_outside:
	move.w  Offset(a5),d0
	move.b  #OBJ_EXT3/4,0(a4,d0.w)
	bra	DestroySprite


Jaws_image:
	incbin "Jaws.bin"
