; *********************************************************************
; 			Mouche
; *********************************************************************

mouche_init:
	moveq	#30,d0
	move.w	d0,BUT_DEST_X(a5)
	move.w	d0,BUT_DEST_Y(a5)
	move.w	d0,BUT_TMP(a5)
	rts

mouche_exe:
	; Move it !
	move.w	Xj(a5),d0
	move.w	Yj(a5),d1
	move.l	d6,d2
	swap	d2			; X position
	move.w	d6,d3			; Y position
	add.w	BUT_DEST_X(a5),d2
	add.w	BUT_DEST_Y(a5),d3	; Set registers
	addq.w	#4,d0
	addq.w	#4,d1
	cmp.w	d0,d2
	bgt.s	\C1
		subq.w	#8,d0
\C1:	cmp.w	d1,d3
	bgt.s	\C2
		subq.w	#8,d1		; Correct new if needed.
\C2:	move.w	d0,Xj(a5)	; Save new values.
	move.w	d1,Yj(a5)

	; Set new position
	subq.w	#1,BUT_TMP(a5)
	bne.s	\NoNew
		move.w	#25,BUT_TMP(a5)
		move.w	BUT_DEST_X(a5),d2
		neg.w	d2
		addq.w	#1,d2
		move.w	d2,BUT_DEST_X(a5)	; Calculate new DecaX
		move.w	BUT_DEST_Y(a5),d2
		neg.w	d2
		addq.w	#1,d2
		move.w	d2,BUT_DEST_Y(a5)	; Calculate new DecaY
\NoNew:	
	
	; Determine sens (H Flipping)
	or.b	#%00000010,Drawing(a5)
	move.l	d6,d2
	swap	d2
	cmp.w	d0,d2
	bls.s	\Ok
		and.b	#%11111101,Drawing(a5)
\Ok:	

	; Coordinate of the center of gravity
	add.w	#19/2,d0
	addq.w	#13/2,d1

	; Collision ?
	test_sonic_collision2.s d0,d1,19,13,d2,d3,Mouc_no_collision
	bra	Hurt
Mouc_no_collision:

	; Exit the screen ?
	test_exit_screen.s d0,d1,d2,Mouc_outside
	rts

Mouc_outside:
	move.w  Offset(a5),d0
	move.b  #OBJ_EXT7/4,0(a4,d0.w)
	bra	DestroySprite


mouche_image:
	incbin "Mouche.bin"

