; *********************************************************************
; 			Monstro
; *********************************************************************

monstro_init:
	move.w	#1,Monstro_vx(a5)
	move.l	d6,d2
	swap	d2
	cmp.w	d0,d2
	bhi.s	\ok
		neg.w	Monstro_vx(a5)
\ok:
	move.w	#15,Monstro_tmp(a5)
	rts

monstro_exe:
	move.w	Xj(a5),d0
	move.w	Yj(a5),d1

	; Check tmp
	subq.w	#1,Monstro_tmp(a5)
	bne.s	\no_reset
		move.w	#30,Monstro_tmp(a5)
		move.w	Monstro_vx(a5),d3
		neg.w	Monstro_vx(a5)
		swap	d3
		clr.w	d3
		moveq	#SPR_EXTRA0,d2
		bsr	Init_sprite
		move.w	#1,d3
		bsr	Init_sprite
		neg.w	d3
		bsr	Init_sprite
\no_reset:
	
	; Move X
	add.w	Monstro_vx(a5),d0
	move.w	d0,Xj(a5)

	; Correction in function of the surface
	addq.w	#8,d0
	add.w	#(17+2),d1
	bsr	Calc_surface
	sub.w	#15,d3
	move.w	d3,Yj(a5)

	; Coordinate of the center of gravity
	move.w	d3,d1
	addq.w	#8,d1

	; Collision ?
	test_sonic_collision2.s d0,d1,18,17,d2,d3,Monstro_no_collision
	bra	Hurt
Monstro_no_collision:

	; Exit the screen ?
	test_exit_screen.s d0,d1,d2,Monstro_outside
	rts

Monstro_outside:
	move.w  Offset(a5),d0
	move.b  #OBJ_EXT8/4,0(a4,d0.w)
	bra	DestroySprite

Monstro_image:
	dc.w	monstro_image1-Monstro_image
	dc.w	monstro_image2-Monstro_image

monstro_image1:
	incbin "monstro1.bin"
monstro_image2:
	incbin "monstro2.bin"
