; *********************************************************************
; 			Mechant Nibbles
; *********************************************************************


nib_init:
	; Set tmp2
	move.w	#5,Nib_tmp2(a5)
nib_calc:
	; Calcul de Vx, Vy et Tmp1
	move.l	d0,-(a7)
	moveq	#6,d0
	bsr	Random
	subq.w	#2,d0
	move.w	d0,Nib_vx(a5)
	moveq	#6,d0
	bsr	Random
	subq.w	#2,d0
	move.w	d0,Nib_vy(a5)
	moveq	#15,d0
	bsr	Random
	addq.w	#8,d0
	move.w	d0,Nib_tmp1(a5)
	move.l	(a7)+,d0
	rts

nib_exe:
	; read X, Y
	move.w	Xj(a5),d0
	move.w	Yj(a5),d1

	; Test tmp2
	subq.w	#1,Nib_tmp2(a5)
	bne.s	\no_init
		moveq	#SPR_EXTRA1,d2
		bsr	Init_sprite
		move.w	#5,Nib_tmp2(a5)
\no_init:
	; Test tmp1
	subq.w	#1,Nib_tmp1(a5)
	bne.s	\no_chg
		bsr.s	nib_calc
\no_chg:
	; Move it !
	add.w	Nib_vx(a5),d0
	add.w	Nib_vy(a5),d1
	move.w	d0,Xj(a5)
	move.w	d1,Yj(a5)

	; Coordinate of the center of gravity
	addq.w	#16/2,d0
	addq.w	#16/2,d1

	; Test rebond
	test_mur2.s	<read_a4>,nib_no_rebond
		neg.w	Nib_vx(a5)
		neg.w	Nib_vy(a5)
nib_no_rebond:

	; Determine sens (H Flipping)
	or.b	#%00000010,Drawing(a5)
	tst.w	Nib_vx(a5)
	blt.s	\Ok
		and.b	#%11111101,Drawing(a5)
\Ok:	

	; Collision ?
	test_sonic_collision2.s d0,d1,16,16,d2,d3,Nib_no_collision
	bra	Hurt
Nib_no_collision:

	; Exit the screen ?
	test_exit_screen.s d0,d1,d2,Nib_outside
	rts

Nib_outside:
	move.w  Offset(a5),d0
	move.b  #OBJ_EXTA/4,0(a4,d0.w)
	bra	DestroySprite

nib_image:
	incbin "boolbase.bin"
