; *********************************************************************
; 			Scarab
; *********************************************************************

scarab_init:
	move.w	#1,Scarab_Vx(a5)
	move.l	d6,d4
	swap	d4
	cmp.w	Xj(a5),d4
	bhi.s	\ok
	neg.w	Scarab_Vx(a5)
\ok:	rts

scarab_exe:
	moveq	#16,d4

	move.w	Xj(a5),d0
	move.w	Yj(a5),d1

	; Move X
	add.w	Scarab_Vx(a5),d0
	move.w	d0,Xj(a5)
	addq.w	#7,d1

	or.b	#%00000010,Drawing(a5)
	tst.w	Scarab_Vx(a5)
	blt.s	\ok
	add.w	d4,d0
	and.b	#%11111101,Drawing(a5)
\ok:	test_mur2.s	<read_a4>,scarab_X_done
	neg.w	Scarab_Vx(a5)
	add.w	Scarab_Vx(a5),d0
scarab_X_done:
	
	; Correction in function of the surface
	move.w	Xj(a5),d0
	addq.w	#7,d0
	add.w	#(17-7),d1
	bsr	Calc_surface
	sub.w	d4,d3
	move.w	d3,Yj(a5)

	; Coordinate of the center of gravity
	move.w	d3,d1
	subq.w	#8,d1

	; Collision ?
	test_sonic_collision2.s d0,d1,16,16,d2,d3,scarab_no_collision
	bra	Hurt
scarab_no_collision:

	; Exit the screen ?
	test_exit_screen.s d0,d1,d2,scarab_outside
	rts

scarab_outside:
	move.w  Offset(a5),d0
	move.b  #OBJ_EXT2/4,0(a4,d0.w)
	bra	DestroySprite


scarab_image:
	incbin "scarab.bin"
