#include "include.h"
#include "macro.h"

#define TILE_BASE 25+3
#define MAX_SIZE 65536

ub create_graph(char *graph_file)
{
 FILE *F1;
 ub *temp;
 ub Name[512];
 ul i,j;
 ul offset = 16*4*TILE_BASE;

 printf("Create graph file : %s\n",graph_file);
 temp = xalloc(sizeof(ub) * (MAX_SIZE +2000));
 sprintf(temp,"%s.bin",graph_file);
 F1 = xopen(temp, "rb");
 j = fread(temp /*+ offset*/, sizeof(ub), MAX_SIZE, F1);
 xclose(F1);
 F1 = xopen("temp.$$$", "wb");
 fwrite(temp,sizeof(ub),j + offset, F1);
 xclose(F1);

 system("shrink92 temp.$$$ -oPack.$$$");

 sprintf(Name,"Pack.$$$",graph_file);
 F1 = xopen(Name,"rb");
 *temp = 'S';
 *(temp+1) = 'X';
 *(temp+2) = '1';
 *(temp+3) = '6';
 j = fread(temp + 4,sizeof(ub), MAX_SIZE, F1);
 xclose(F1);
 sprintf(Name,"%s.92S",graph_file);
 i = (Create92S(temp, j + 4, Name));
 free(temp);
 return i;
}

int	main(int argc, char *argv[])
{
 puts("mkgfx gfx");
 if (argc<2)
	return;
 create_graph(argv[1]);
}